/* Generated automatically by the program `genopinit'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"

struct optab_pat {
  unsigned scode;
  enum insn_code icode;
};

static const struct optab_pat pats[NUM_OPTAB_PATTERNS] = {
  { 0x010f10, CODE_FOR_extendqihi2 },
  { 0x010f11, CODE_FOR_extendqisi2 },
  { 0x011011, CODE_FOR_extendhisi2 },
  { 0x012627, CODE_FOR_extendsfdf2 },
  { 0x022726, CODE_FOR_truncdfsf2 },
  { 0x030f10, CODE_FOR_zero_extendqihi2 },
  { 0x030f11, CODE_FOR_zero_extendqisi2 },
  { 0x031011, CODE_FOR_zero_extendhisi2 },
  { 0x061126, CODE_FOR_floatsisf2 },
  { 0x061127, CODE_FOR_floatsidf2 },
  { 0x061226, CODE_FOR_floatdisf2 },
  { 0x061227, CODE_FOR_floatdidf2 },
  { 0x071126, CODE_FOR_floatunssisf2 },
  { 0x071127, CODE_FOR_floatunssidf2 },
  { 0x071226, CODE_FOR_floatunsdisf2 },
  { 0x071227, CODE_FOR_floatunsdidf2 },
  { 0x102611, CODE_FOR_fix_truncsfsi2 },
  { 0x102612, CODE_FOR_fix_truncsfdi2 },
  { 0x102711, CODE_FOR_fix_truncdfsi2 },
  { 0x102712, CODE_FOR_fix_truncdfdi2 },
  { 0x112611, CODE_FOR_fixuns_truncsfsi2 },
  { 0x112612, CODE_FOR_fixuns_truncsfdi2 },
  { 0x112711, CODE_FOR_fixuns_truncdfsi2 },
  { 0x112712, CODE_FOR_fixuns_truncdfdi2 },
  { 0x121011, CODE_FOR_mulhisi3 },
  { 0x121112, CODE_FOR_mulsidi3 },
  { 0x131011, CODE_FOR_umulhisi3 },
  { 0x131112, CODE_FOR_umulsidi3 },
  { 0x151112, CODE_FOR_maddsidi4 },
  { 0x161112, CODE_FOR_umaddsidi4 },
  { 0x310011, CODE_FOR_addsi3 },
  { 0x310012, CODE_FOR_adddi3 },
  { 0x310026, CODE_FOR_addsf3 },
  { 0x310027, CODE_FOR_adddf3 },
  { 0x310033, CODE_FOR_addv2hi3 },
  { 0x310035, CODE_FOR_addv4hi3 },
  { 0x310036, CODE_FOR_addv2si3 },
  { 0x350011, CODE_FOR_subsi3 },
  { 0x350012, CODE_FOR_subdi3 },
  { 0x350026, CODE_FOR_subsf3 },
  { 0x350027, CODE_FOR_subdf3 },
  { 0x350033, CODE_FOR_subv2hi3 },
  { 0x350035, CODE_FOR_subv4hi3 },
  { 0x350036, CODE_FOR_subv2si3 },
  { 0x390011, CODE_FOR_mulsi3 },
  { 0x390026, CODE_FOR_mulsf3 },
  { 0x390027, CODE_FOR_muldf3 },
  { 0x3d0011, CODE_FOR_divsi3 },
  { 0x3d0026, CODE_FOR_divsf3 },
  { 0x3d0027, CODE_FOR_divdf3 },
  { 0x400011, CODE_FOR_udivsi3 },
  { 0x440011, CODE_FOR_modsi3 },
  { 0x450011, CODE_FOR_umodsi3 },
  { 0x470011, CODE_FOR_andsi3 },
  { 0x480011, CODE_FOR_iorsi3 },
  { 0x490011, CODE_FOR_xorsi3 },
  { 0x4a0011, CODE_FOR_ashlsi3 },
  { 0x4d0011, CODE_FOR_ashrsi3 },
  { 0x4e0011, CODE_FOR_lshrsi3 },
  { 0x500011, CODE_FOR_rotrsi3 },
  { 0x560011, CODE_FOR_sminsi3 },
  { 0x570011, CODE_FOR_smaxsi3 },
  { 0x5a0011, CODE_FOR_negsi2 },
  { 0x5a0026, CODE_FOR_negsf2 },
  { 0x5e0011, CODE_FOR_abssi2 },
  { 0x5e0026, CODE_FOR_abssf2 },
  { 0x600011, CODE_FOR_one_cmplsi2 },
  { 0x600012, CODE_FOR_one_cmpldi2 },
  { 0x610011, CODE_FOR_bswapsi2 },
  { 0x610033, CODE_FOR_bswapv2hi2 },
  { 0x620011, CODE_FOR_ffssi2 },
  { 0x630011, CODE_FOR_clzsi2 },
  { 0x640011, CODE_FOR_ctzsi2 },
  { 0x650010, CODE_FOR_clrsbhi2 },
  { 0x650011, CODE_FOR_clrsbsi2 },
  { 0x720026, CODE_FOR_sqrtsf2 },
  { 0x720027, CODE_FOR_sqrtdf2 },
  { 0x81000f, CODE_FOR_movqi },
  { 0x810010, CODE_FOR_movhi },
  { 0x810011, CODE_FOR_movsi },
  { 0x810012, CODE_FOR_movdi },
  { 0x810026, CODE_FOR_movsf },
  { 0x810027, CODE_FOR_movdf },
  { 0x810033, CODE_FOR_movv2hi },
  { 0x810035, CODE_FOR_movv4hi },
  { 0x810036, CODE_FOR_movv2si },
  { 0x810038, CODE_FOR_movv8hi },
  { 0x830033, CODE_FOR_movmisalignv2hi },
  { 0x830035, CODE_FOR_movmisalignv4hi },
  { 0x830036, CODE_FOR_movmisalignv2si },
  { 0x870011, CODE_FOR_extzvsi },
  { 0x8e0011, CODE_FOR_cbranchsi4 },
  { 0x8e0026, CODE_FOR_cbranchsf4 },
  { 0x8e0027, CODE_FOR_cbranchdf4 },
  { 0x920011, CODE_FOR_movsicc },
  { 0x920012, CODE_FOR_movdicc },
  { 0x920026, CODE_FOR_movsfcc },
  { 0x920027, CODE_FOR_movdfcc },
  { 0xa90011, CODE_FOR_cstoresi4 },
  { 0xa90026, CODE_FOR_cstoresf4 },
  { 0xa90027, CODE_FOR_cstoredf4 },
  { 0xb40011, CODE_FOR_umulsi3_highpart },
  { 0xb80011, CODE_FOR_cpymemsi },
  { 0xbc0026, CODE_FOR_fmasf4 },
  { 0xbc0027, CODE_FOR_fmadf4 },
  { 0xbe0026, CODE_FOR_fnmasf4 },
  { 0xbe0027, CODE_FOR_fnmadf4 },
  { 0xfd0033, CODE_FOR_sdot_prodv2hi },
  { 0xff0033, CODE_FOR_udot_prodv2hi },
  { 0x1240035, CODE_FOR_vec_widen_smult_hi_v4hi },
  { 0x1250035, CODE_FOR_vec_widen_smult_lo_v4hi },
  { 0x12a0035, CODE_FOR_vec_widen_umult_hi_v4hi },
  { 0x12b0035, CODE_FOR_vec_widen_umult_lo_v4hi },
  { 0x1360011, CODE_FOR_atomic_add_fetchsi },
  { 0x1370011, CODE_FOR_atomic_addsi },
  { 0x1380011, CODE_FOR_atomic_and_fetchsi },
  { 0x1390011, CODE_FOR_atomic_andsi },
  { 0x13d000f, CODE_FOR_atomic_compare_and_swapqi },
  { 0x13d0010, CODE_FOR_atomic_compare_and_swaphi },
  { 0x13d0011, CODE_FOR_atomic_compare_and_swapsi },
  { 0x13e0011, CODE_FOR_atomic_exchangesi },
  { 0x13f0011, CODE_FOR_atomic_fetch_addsi },
  { 0x1400011, CODE_FOR_atomic_fetch_andsi },
  { 0x1410011, CODE_FOR_atomic_fetch_nandsi },
  { 0x1420011, CODE_FOR_atomic_fetch_orsi },
  { 0x1430011, CODE_FOR_atomic_fetch_subsi },
  { 0x1440011, CODE_FOR_atomic_fetch_xorsi },
  { 0x1460011, CODE_FOR_atomic_nand_fetchsi },
  { 0x1470011, CODE_FOR_atomic_nandsi },
  { 0x1480011, CODE_FOR_atomic_or_fetchsi },
  { 0x1490011, CODE_FOR_atomic_orsi },
  { 0x14b0011, CODE_FOR_atomic_sub_fetchsi },
  { 0x14c0011, CODE_FOR_atomic_subsi },
  { 0x14d0011, CODE_FOR_atomic_xor_fetchsi },
  { 0x14e0011, CODE_FOR_atomic_xorsi },
  { 0x14f0011, CODE_FOR_get_thread_pointersi },
  { 0x1500011, CODE_FOR_set_thread_pointersi },
};

void
init_all_optabs (struct target_optabs *optabs)
{
  bool *ena = optabs->pat_enable;
  ena[0] = HAVE_extendqihi2;
  ena[1] = HAVE_extendqisi2;
  ena[2] = HAVE_extendhisi2;
  ena[3] = HAVE_extendsfdf2;
  ena[4] = HAVE_truncdfsf2;
  ena[5] = HAVE_zero_extendqihi2;
  ena[6] = HAVE_zero_extendqisi2;
  ena[7] = HAVE_zero_extendhisi2;
  ena[8] = HAVE_floatsisf2;
  ena[9] = HAVE_floatsidf2;
  ena[10] = HAVE_floatdisf2;
  ena[11] = HAVE_floatdidf2;
  ena[12] = HAVE_floatunssisf2;
  ena[13] = HAVE_floatunssidf2;
  ena[14] = HAVE_floatunsdisf2;
  ena[15] = HAVE_floatunsdidf2;
  ena[16] = HAVE_fix_truncsfsi2;
  ena[17] = HAVE_fix_truncsfdi2;
  ena[18] = HAVE_fix_truncdfsi2;
  ena[19] = HAVE_fix_truncdfdi2;
  ena[20] = HAVE_fixuns_truncsfsi2;
  ena[21] = HAVE_fixuns_truncsfdi2;
  ena[22] = HAVE_fixuns_truncdfsi2;
  ena[23] = HAVE_fixuns_truncdfdi2;
  ena[24] = HAVE_mulhisi3;
  ena[25] = HAVE_mulsidi3;
  ena[26] = HAVE_umulhisi3;
  ena[27] = HAVE_umulsidi3;
  ena[28] = HAVE_maddsidi4;
  ena[29] = HAVE_umaddsidi4;
  ena[30] = HAVE_addsi3;
  ena[31] = HAVE_adddi3;
  ena[32] = HAVE_addsf3;
  ena[33] = HAVE_adddf3;
  ena[34] = HAVE_addv2hi3;
  ena[35] = HAVE_addv4hi3;
  ena[36] = HAVE_addv2si3;
  ena[37] = HAVE_subsi3;
  ena[38] = HAVE_subdi3;
  ena[39] = HAVE_subsf3;
  ena[40] = HAVE_subdf3;
  ena[41] = HAVE_subv2hi3;
  ena[42] = HAVE_subv4hi3;
  ena[43] = HAVE_subv2si3;
  ena[44] = HAVE_mulsi3;
  ena[45] = HAVE_mulsf3;
  ena[46] = HAVE_muldf3;
  ena[47] = HAVE_divsi3;
  ena[48] = HAVE_divsf3;
  ena[49] = HAVE_divdf3;
  ena[50] = HAVE_udivsi3;
  ena[51] = HAVE_modsi3;
  ena[52] = HAVE_umodsi3;
  ena[53] = HAVE_andsi3;
  ena[54] = HAVE_iorsi3;
  ena[55] = HAVE_xorsi3;
  ena[56] = HAVE_ashlsi3;
  ena[57] = HAVE_ashrsi3;
  ena[58] = HAVE_lshrsi3;
  ena[59] = HAVE_rotrsi3;
  ena[60] = HAVE_sminsi3;
  ena[61] = HAVE_smaxsi3;
  ena[62] = HAVE_negsi2;
  ena[63] = HAVE_negsf2;
  ena[64] = HAVE_abssi2;
  ena[65] = HAVE_abssf2;
  ena[66] = HAVE_one_cmplsi2;
  ena[67] = HAVE_one_cmpldi2;
  ena[68] = HAVE_bswapsi2;
  ena[69] = HAVE_bswapv2hi2;
  ena[70] = HAVE_ffssi2;
  ena[71] = HAVE_clzsi2;
  ena[72] = HAVE_ctzsi2;
  ena[73] = HAVE_clrsbhi2;
  ena[74] = HAVE_clrsbsi2;
  ena[75] = HAVE_sqrtsf2;
  ena[76] = HAVE_sqrtdf2;
  ena[77] = HAVE_movqi;
  ena[78] = HAVE_movhi;
  ena[79] = HAVE_movsi;
  ena[80] = HAVE_movdi;
  ena[81] = HAVE_movsf;
  ena[82] = HAVE_movdf;
  ena[83] = HAVE_movv2hi;
  ena[84] = HAVE_movv4hi;
  ena[85] = HAVE_movv2si;
  ena[86] = HAVE_movv8hi;
  ena[87] = HAVE_movmisalignv2hi;
  ena[88] = HAVE_movmisalignv4hi;
  ena[89] = HAVE_movmisalignv2si;
  ena[90] = HAVE_extzvsi;
  ena[91] = HAVE_cbranchsi4;
  ena[92] = HAVE_cbranchsf4;
  ena[93] = HAVE_cbranchdf4;
  ena[94] = HAVE_movsicc;
  ena[95] = HAVE_movdicc;
  ena[96] = HAVE_movsfcc;
  ena[97] = HAVE_movdfcc;
  ena[98] = HAVE_cstoresi4;
  ena[99] = HAVE_cstoresf4;
  ena[100] = HAVE_cstoredf4;
  ena[101] = HAVE_umulsi3_highpart;
  ena[102] = HAVE_cpymemsi;
  ena[103] = HAVE_fmasf4;
  ena[104] = HAVE_fmadf4;
  ena[105] = HAVE_fnmasf4;
  ena[106] = HAVE_fnmadf4;
  ena[107] = HAVE_sdot_prodv2hi;
  ena[108] = HAVE_udot_prodv2hi;
  ena[109] = HAVE_vec_widen_smult_hi_v4hi;
  ena[110] = HAVE_vec_widen_smult_lo_v4hi;
  ena[111] = HAVE_vec_widen_umult_hi_v4hi;
  ena[112] = HAVE_vec_widen_umult_lo_v4hi;
  ena[113] = HAVE_atomic_add_fetchsi;
  ena[114] = HAVE_atomic_addsi;
  ena[115] = HAVE_atomic_and_fetchsi;
  ena[116] = HAVE_atomic_andsi;
  ena[117] = HAVE_atomic_compare_and_swapqi;
  ena[118] = HAVE_atomic_compare_and_swaphi;
  ena[119] = HAVE_atomic_compare_and_swapsi;
  ena[120] = HAVE_atomic_exchangesi;
  ena[121] = HAVE_atomic_fetch_addsi;
  ena[122] = HAVE_atomic_fetch_andsi;
  ena[123] = HAVE_atomic_fetch_nandsi;
  ena[124] = HAVE_atomic_fetch_orsi;
  ena[125] = HAVE_atomic_fetch_subsi;
  ena[126] = HAVE_atomic_fetch_xorsi;
  ena[127] = HAVE_atomic_nand_fetchsi;
  ena[128] = HAVE_atomic_nandsi;
  ena[129] = HAVE_atomic_or_fetchsi;
  ena[130] = HAVE_atomic_orsi;
  ena[131] = HAVE_atomic_sub_fetchsi;
  ena[132] = HAVE_atomic_subsi;
  ena[133] = HAVE_atomic_xor_fetchsi;
  ena[134] = HAVE_atomic_xorsi;
  ena[135] = HAVE_get_thread_pointersi;
  ena[136] = HAVE_set_thread_pointersi;
}

static int
lookup_handler (unsigned scode)
{
  int l = 0, h = ARRAY_SIZE (pats), m;
  while (h > l)
    {
      m = (h + l) / 2;
      if (scode == pats[m].scode)
        return m;
      else if (scode < pats[m].scode)
        h = m;
      else
        l = m + 1;
    }
  return -1;
}

enum insn_code
raw_optab_handler (unsigned scode)
{
  int i = lookup_handler (scode);
  return (i >= 0 && this_fn_optabs->pat_enable[i]
          ? pats[i].icode : CODE_FOR_nothing);
}

bool
swap_optab_enable (optab op, machine_mode m, bool set)
{
  unsigned scode = (op << 16) | m;
  int i = lookup_handler (scode);
  if (i >= 0)
    {
      bool ret = this_fn_optabs->pat_enable[i];
      this_fn_optabs->pat_enable[i] = set;
      return ret;
    }
  else
    {
      gcc_assert (!set);
      return false;
    }
}

const struct convert_optab_libcall_d convlib_def[NUM_CONVLIB_OPTABS] = {
  { "extend", gen_extend_conv_libfunc },
  { "trunc", gen_trunc_conv_libfunc },
  { NULL, NULL },
  { "fix", gen_fp_to_int_conv_libfunc },
  { "fixuns", gen_fp_to_int_conv_libfunc },
  { "float", gen_int_to_fp_conv_libfunc },
  { NULL, gen_ufloat_conv_libfunc },
  { "lrint", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lround", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lfloor", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lceil", gen_int_to_fp_nondecimal_conv_libfunc },
  { "fract", gen_fract_conv_libfunc },
  { "fractuns", gen_fractuns_conv_libfunc },
  { "satfract", gen_satfract_conv_libfunc },
  { "satfractuns", gen_satfractuns_conv_libfunc },
};

const struct optab_libcall_d normlib_def[NUM_NORMLIB_OPTABS] = {
  { '3', "add", gen_int_fp_fixed_libfunc },
  { '3', "add", gen_intv_fp_libfunc },
  { '3', "ssadd", gen_signed_fixed_libfunc },
  { '3', "usadd", gen_unsigned_fixed_libfunc },
  { '3', "sub", gen_int_fp_fixed_libfunc },
  { '3', "sub", gen_intv_fp_libfunc },
  { '3', "sssub", gen_signed_fixed_libfunc },
  { '3', "ussub", gen_unsigned_fixed_libfunc },
  { '3', "mul", gen_int_fp_fixed_libfunc },
  { '3', "mul", gen_intv_fp_libfunc },
  { '3', "ssmul", gen_signed_fixed_libfunc },
  { '3', "usmul", gen_unsigned_fixed_libfunc },
  { '3', "div", gen_int_fp_signed_fixed_libfunc },
  { '3', "divv", gen_int_libfunc },
  { '3', "ssdiv", gen_signed_fixed_libfunc },
  { '3', "udiv", gen_int_unsigned_fixed_libfunc },
  { '3', "usdiv", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "mod", gen_int_libfunc },
  { '3', "umod", gen_int_libfunc },
  { '2', "ftrunc", gen_fp_libfunc },
  { '3', "and", gen_int_libfunc },
  { '3', "ior", gen_int_libfunc },
  { '3', "xor", gen_int_libfunc },
  { '3', "ashl", gen_int_fixed_libfunc },
  { '3', "ssashl", gen_signed_fixed_libfunc },
  { '3', "usashl", gen_unsigned_fixed_libfunc },
  { '3', "ashr", gen_int_signed_fixed_libfunc },
  { '3', "lshr", gen_int_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "min", gen_int_fp_libfunc },
  { '3', "max", gen_int_fp_libfunc },
  { '3', "umin", gen_int_libfunc },
  { '3', "umax", gen_int_libfunc },
  { '2', "neg", gen_int_fp_fixed_libfunc },
  { '2', "neg", gen_intv_fp_libfunc },
  { '2', "ssneg", gen_signed_fixed_libfunc },
  { '2', "usneg", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '2', "one_cmpl", gen_int_libfunc },
  { '\0', NULL, NULL },
  { '2', "ffs", gen_int_libfunc },
  { '2', "clz", gen_int_libfunc },
  { '2', "ctz", gen_int_libfunc },
  { '2', "clrsb", gen_int_libfunc },
  { '2', "popcount", gen_int_libfunc },
  { '2', "parity", gen_int_libfunc },
  { '2', "cmp", gen_int_fp_fixed_libfunc },
  { '2', "ucmp", gen_int_libfunc },
  { '2', "eq", gen_fp_libfunc },
  { '2', "ne", gen_fp_libfunc },
  { '2', "gt", gen_fp_libfunc },
  { '2', "ge", gen_fp_libfunc },
  { '2', "lt", gen_fp_libfunc },
  { '2', "le", gen_fp_libfunc },
  { '2', "unord", gen_fp_libfunc },
  { '2', "powi", gen_fp_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
};

enum rtx_code const optab_to_code_[NUM_OPTABS] = {
  UNKNOWN,
  SIGN_EXTEND,
  TRUNCATE,
  ZERO_EXTEND,
  FIX,
  UNSIGNED_FIX,
  FLOAT,
  UNSIGNED_FLOAT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FRACT_CONVERT,
  UNSIGNED_FRACT_CONVERT,
  SAT_FRACT,
  UNSIGNED_SAT_FRACT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  PLUS,
  PLUS,
  SS_PLUS,
  US_PLUS,
  MINUS,
  MINUS,
  SS_MINUS,
  US_MINUS,
  MULT,
  MULT,
  SS_MULT,
  US_MULT,
  DIV,
  DIV,
  SS_DIV,
  UDIV,
  US_DIV,
  UNKNOWN,
  UNKNOWN,
  MOD,
  UMOD,
  UNKNOWN,
  AND,
  IOR,
  XOR,
  ASHIFT,
  SS_ASHIFT,
  US_ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  SMIN,
  SMAX,
  UMIN,
  UMAX,
  NEG,
  NEG,
  SS_NEG,
  US_NEG,
  ABS,
  ABS,
  NOT,
  BSWAP,
  FFS,
  CLZ,
  CTZ,
  CLRSB,
  POPCOUNT,
  PARITY,
  UNKNOWN,
  UNKNOWN,
  EQ,
  NE,
  GT,
  GE,
  LT,
  LE,
  UNORDERED,
  UNKNOWN,
  SQRT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  SET,
  STRICT_LOW_PART,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  COMPARE,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FMA,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  VEC_DUPLICATE,
  VEC_SERIES,
  UNKNOWN,
};

const optab code_to_optab_[NUM_RTX_CODE] = {
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  mov_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  movstrict_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  cbranch_optab,
  add_optab,
  sub_optab,
  neg_optab,
  smul_optab,
  ssmul_optab,
  usmul_optab,
  sdiv_optab,
  ssdiv_optab,
  usdiv_optab,
  smod_optab,
  udiv_optab,
  umod_optab,
  and_optab,
  ior_optab,
  xor_optab,
  one_cmpl_optab,
  ashl_optab,
  rotl_optab,
  ashr_optab,
  lshr_optab,
  rotr_optab,
  smin_optab,
  smax_optab,
  umin_optab,
  umax_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  ne_optab,
  eq_optab,
  ge_optab,
  gt_optab,
  le_optab,
  lt_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unord_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  abs_optab,
  sqrt_optab,
  bswap_optab,
  ffs_optab,
  clrsb_optab,
  clz_optab,
  ctz_optab,
  popcount_optab,
  parity_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  vec_duplicate_optab,
  vec_series_optab,
  ssadd_optab,
  usadd_optab,
  sssub_optab,
  ssneg_optab,
  usneg_optab,
  unknown_optab,
  ssashl_optab,
  usashl_optab,
  ussub_optab,
  unknown_optab,
  unknown_optab,
  fma_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
};

