/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"



/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.

   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it
   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.c) to fill in the CLOBBERs.


   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/


extern rtx_insn *gen_split_1 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_2 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_3 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_4 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_5 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_6 (rtx_insn *, rtx *);




static int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!arith_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != IF_THEN_ELSE)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NE)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XEXP (x3, 2);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_CODE (x8) != PC)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != SET)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != PLUS)
    return -1;
  return 0;
}

static int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 6
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 0
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

static int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 7
      || GET_MODE (x4) != E_SImode)
    return -1;
  return 0;
}

static int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case REG:
    case SUBREG:
      operands[1] = x1;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case MULT:
      if (GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x3 = XEXP (x1, 1);
      operands[3] = x3;
      if (!addsubx_operand (operands[3], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern6 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_HImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_HImode))
    return -1;
  return 0;
}

static int
pattern7 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 13)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  return 0;
}

static int
pattern8 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PC)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  if (!branch_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  switch (GET_CODE (x7))
    {
    case LABEL_REF:
      x8 = XEXP (x3, 2);
      if (GET_CODE (x8) != PC)
        return -1;
      x9 = XEXP (x7, 0);
      operands[2] = x9;
      return 39; /* *btrue */

    case PC:
      x8 = XEXP (x3, 2);
      if (GET_CODE (x8) != LABEL_REF)
        return -1;
      x10 = XEXP (x8, 0);
      operands[2] = x10;
      return 40; /* *bfalse */

    default:
      return -1;
    }
}

static int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 2);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern8 (x2, E_SImode) != 0)
        return -1;
      return 50; /* movsicc_internal0 */

    case E_SFmode:
      if (pattern8 (x2, E_SFmode) != 0)
        return -1;
      return 51; /* movsfcc_internal0 */

    default:
      return -1;
    }
}

static int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      x5 = XEXP (x2, 0);
      switch (pattern5 (x5))
        {
        case 0:
          if (!add_operand (operands[2], E_SImode))
            return -1;
          return 1; /* addsi3 */

        case 1:
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 2; /* *addx */

        default:
          return -1;
        }

    case MINUS:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x2, 0);
      switch (pattern5 (x5))
        {
        case 0:
          return 3; /* subsi3 */

        case 1:
          return 4; /* *subx */

        default:
          return -1;
        }

    case MULT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x5 = XEXP (x2, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x4 = XEXP (x2, 1);
          operands[2] = x4;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 5; /* mulsi3 */

        case SIGN_EXTEND:
          if (pattern6 (x2, SIGN_EXTEND) != 0)
            return -1;
          return 6; /* mulhisi3 */

        case ZERO_EXTEND:
          if (pattern6 (x2, ZERO_EXTEND) != 0)
            return -1;
          return 7; /* umulhisi3 */

        default:
          return -1;
        }

    case DIV:
      if (pattern0 (x1) != 0)
        return -1;
      return 8; /* divsi3 */

    case UDIV:
      if (pattern0 (x1) != 0)
        return -1;
      return 9; /* udivsi3 */

    case MOD:
      if (pattern0 (x1) != 0)
        return -1;
      return 10; /* modsi3 */

    case UMOD:
      if (pattern0 (x1) != 0)
        return -1;
      return 11; /* umodsi3 */

    case ABS:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 12; /* abssi2 */

    case SMIN:
      if (pattern0 (x1) != 0)
        return -1;
      return 13; /* sminsi3 */

    case UMIN:
      if (pattern0 (x1) != 0)
        return -1;
      return 14; /* uminsi3 */

    case SMAX:
      if (pattern0 (x1) != 0)
        return -1;
      return 15; /* smaxsi3 */

    case UMAX:
      if (pattern0 (x1) != 0)
        return -1;
      return 16; /* umaxsi3 */

    case CLZ:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 17; /* clzsi2 */

    case NEG:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 18; /* negsi2 */

    case AND:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (!mask_operand (operands[2], E_SImode))
        return -1;
      return 19; /* andsi3 */

    case IOR:
      if (pattern0 (x1) != 0)
        return -1;
      return 20; /* iorsi3 */

    case XOR:
      if (pattern0 (x1) != 0)
        return -1;
      return 21; /* xorsi3 */

    case ZERO_EXTEND:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!nonimmed_operand (operands[1], E_HImode))
            return -1;
          return 22; /* zero_extendhisi2 */

        case E_QImode:
          if (!nonimmed_operand (operands[1], E_QImode))
            return -1;
          return 23; /* zero_extendqisi2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!sext_operand (operands[1], E_HImode))
            return -1;
          return 24; /* extendhisi2_internal */

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 25; /* extendqisi2_internal */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (!sext_fldsz_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x2, 2);
      operands[3] = x6;
      if (!lsbitnum_operand (operands[3], E_SImode))
        return -1;
      return 26; /* extv_internal */

    case ZERO_EXTRACT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (!extui_fldsz_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x2, 2);
      operands[3] = x6;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      return 27; /* extzv_internal */

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
      x3 = XEXP (x1, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x3;
          operands[1] = x2;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (nonimmed_operand (operands[0], E_DImode)
                  && move_operand (operands[1], E_DImode)
                  && 
#line 737 "../../gcc-10.2.1-20200826/gcc/config/xtensa/xtensa.md"
(register_operand (operands[0], DImode)
   || register_operand (operands[1], DImode)))
                return 28; /* movdi_internal */
              break;

            case E_SImode:
              if (nonimmed_operand (operands[0], E_SImode)
                  && move_operand (operands[1], E_SImode)
                  && 
#line 767 "../../gcc-10.2.1-20200826/gcc/config/xtensa/xtensa.md"
(xtensa_valid_move (SImode, operands)))
                return 29; /* movsi_internal */
              break;

            case E_HImode:
              if (nonimmed_operand (operands[0], E_HImode)
                  && move_operand (operands[1], E_HImode)
                  && 
#line 803 "../../gcc-10.2.1-20200826/gcc/config/xtensa/xtensa.md"
(xtensa_valid_move (HImode, operands)))
                return 30; /* movhi_internal */
              break;

            case E_QImode:
              if (nonimmed_operand (operands[0], E_QImode)
                  && move_operand (operands[1], E_QImode)
                  && 
#line 832 "../../gcc-10.2.1-20200826/gcc/config/xtensa/xtensa.md"
(xtensa_valid_move (QImode, operands)))
                return 31; /* movqi_internal */
              break;

            case E_SFmode:
              if (nonimmed_operand (operands[0], E_SFmode)
                  && move_operand (operands[1], E_SFmode)
                  && 
#line 904 "../../gcc-10.2.1-20200826/gcc/config/xtensa/xtensa.md"
(((register_operand (operands[0], SFmode)
     || register_operand (operands[1], SFmode))
    && !(FP_REG_P (xt_true_regnum (operands[0]))
         && (constantpool_mem_p (operands[1]) || CONSTANT_P (operands[1]))))))
                return 32; /* movsf_internal */
              break;

            case E_DFmode:
              if (nonimmed_operand (operands[0], E_DFmode)
                  && move_operand (operands[1], E_DFmode)
                  && 
#line 1011 "../../gcc-10.2.1-20200826/gcc/config/xtensa/xtensa.md"
(register_operand (operands[0], DFmode)
   || register_operand (operands[1], DFmode)))
                return 33; /* movdf_internal */
              break;

            default:
              break;
            }
          break;

        case PC:
          operands[0] = x2;
          if (register_operand (operands[0], E_SImode))
            return 53; /* indirect_jump_internal */
          break;

        default:
          break;
        }
      if (GET_CODE (x2) != LABEL_REF
          || GET_CODE (x3) != PC)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      return 52; /* jump */

    case ASHIFT:
      if (pattern1 (x1) != 0)
        return -1;
      return 34; /* ashlsi3_internal */

    case ASHIFTRT:
      if (pattern1 (x1) != 0)
        return -1;
      return 35; /* ashrsi3 */

    case LSHIFTRT:
      if (pattern1 (x1) != 0)
        return -1;
      return 36; /* lshrsi3 */

    case ROTATE:
      if (pattern1 (x1) != 0)
        return -1;
      return 37; /* rotlsi3 */

    case ROTATERT:
      if (pattern1 (x1) != 0)
        return -1;
      return 38; /* rotrsi3 */

    case IF_THEN_ELSE:
      x5 = XEXP (x2, 0);
      switch (GET_CODE (x5))
        {
        case NE:
        case EQ:
        case GE:
        case LT:
          operands[3] = x5;
          if (branch_operator (operands[3], E_VOIDmode))
            {
              res = recog_1 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[4] = x5;
          if (branch_operator (operands[4], E_VOIDmode))
            {
              res = recog_2 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (!boolean_operator (x5, E_VOIDmode))
            return -1;
          operands[3] = x5;
          x7 = XEXP (x5, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != PC)
            return -1;
          x8 = XEXP (x5, 0);
          if (GET_MODE (x8) != E_SImode)
            return -1;
          switch (GET_CODE (x8))
            {
            case ZERO_EXTRACT:
              x9 = XEXP (x8, 1);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x10 = XEXP (x8, 0);
              operands[0] = x10;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x11 = XEXP (x8, 2);
              operands[1] = x11;
              if (!arith_operand (operands[1], E_SImode))
                return -1;
              x4 = XEXP (x2, 1);
              switch (GET_CODE (x4))
                {
                case LABEL_REF:
                  x6 = XEXP (x2, 2);
                  if (GET_CODE (x6) != PC)
                    return -1;
                  x12 = XEXP (x4, 0);
                  operands[2] = x12;
                  return 43; /* *bittrue */

                case PC:
                  x6 = XEXP (x2, 2);
                  if (GET_CODE (x6) != LABEL_REF)
                    return -1;
                  x13 = XEXP (x6, 0);
                  operands[2] = x13;
                  return 44; /* *bitfalse */

                default:
                  return -1;
                }

            case AND:
              x10 = XEXP (x8, 0);
              operands[0] = x10;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x9 = XEXP (x8, 1);
              operands[1] = x9;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x4 = XEXP (x2, 1);
              switch (GET_CODE (x4))
                {
                case LABEL_REF:
                  x6 = XEXP (x2, 2);
                  if (GET_CODE (x6) != PC)
                    return -1;
                  x12 = XEXP (x4, 0);
                  operands[2] = x12;
                  return 45; /* *masktrue */

                case PC:
                  x6 = XEXP (x2, 2);
                  if (GET_CODE (x6) != LABEL_REF)
                    return -1;
                  x13 = XEXP (x6, 0);
                  operands[2] = x13;
                  return 46; /* *maskfalse */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case GEU:
        case LTU:
          operands[3] = x5;
          if (!ubranch_operator (operands[3], E_VOIDmode))
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != PC)
            return -1;
          x8 = XEXP (x5, 0);
          operands[0] = x8;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x7 = XEXP (x5, 1);
          operands[1] = x7;
          if (!ubranch_operand (operands[1], E_SImode))
            return -1;
          x4 = XEXP (x2, 1);
          switch (GET_CODE (x4))
            {
            case LABEL_REF:
              x6 = XEXP (x2, 2);
              if (GET_CODE (x6) != PC)
                return -1;
              x12 = XEXP (x4, 0);
              operands[2] = x12;
              return 41; /* *ubtrue */

            case PC:
              x6 = XEXP (x2, 2);
              if (GET_CODE (x6) != LABEL_REF)
                return -1;
              x13 = XEXP (x6, 0);
              operands[2] = x13;
              return 42; /* *ubfalse */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != MEM)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x8 = XEXP (x5, 0);
      switch (GET_CODE (x8))
        {
        case CONST_INT:
        case CONST:
        case REG:
        case SYMBOL_REF:
          operands[1] = x8;
          if (!call_insn_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_VOIDmode))
            return -1;
          x4 = XEXP (x2, 1);
          operands[2] = x4;
          return 56; /* call_value_internal */

        case UNSPEC:
          if (XVECLEN (x8, 0) != 2
              || XINT (x8, 1) != 9
              || GET_MODE (x8) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x5) != E_SImode)
            return -1;
          x14 = XVECEXP (x8, 0, 0);
          operands[1] = x14;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x15 = XVECEXP (x8, 0, 1);
          operands[2] = x15;
          if (!tls_symbol_operand (operands[2], E_SImode))
            return -1;
          x4 = XEXP (x2, 1);
          operands[3] = x4;
          return 71; /* tls_call */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (XINT (x2, 1))
        {
        case 2:
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != REG
              || REGNO (x3) != 1
              || GET_MODE (x3) != E_SImode)
            return -1;
          x16 = XVECEXP (x2, 0, 0);
          operands[0] = x16;
          if (!const_int_operand (operands[0], E_SImode))
            return -1;
          return 57; /* entry */

        case 6:
          if (pnum_clobbers == NULL)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != REG
              || REGNO (x3) != 0
              || GET_MODE (x3) != E_SImode)
            return -1;
          x16 = XVECEXP (x2, 0, 0);
          operands[0] = x16;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 60; /* eh_set_a0_windowed */

        case 1:
          if (pattern4 (x1) != 0)
            return -1;
          return 65; /* set_frame_ptr */

        case 4:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!mem_operand (operands[0], E_SImode))
            return -1;
          x16 = XVECEXP (x2, 0, 0);
          operands[1] = x16;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 73; /* sync_lock_releasesi */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x2, 0) != 1)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XINT (x2, 1))
        {
        case 14:
          if (GET_MODE (x2) != E_BLKmode)
            return -1;
          x16 = XVECEXP (x2, 0, 0);
          operands[1] = x16;
          return 63; /* *frame_blockage */

        case 10:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x16 = XVECEXP (x2, 0, 0);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_SImode))
            return -1;
          return 67; /* get_thread_pointersi */

        case 7:
          if (GET_MODE (x2) != E_SImode
              || !register_operand (operands[0], E_SImode))
            return -1;
          x16 = XVECEXP (x2, 0, 0);
          operands[1] = x16;
          if (!tls_symbol_operand (operands[1], E_SImode))
            return -1;
          return 69; /* tls_func */

        case 8:
          if (GET_MODE (x2) != E_SImode
              || !register_operand (operands[0], E_SImode))
            return -1;
          x16 = XVECEXP (x2, 0, 0);
          operands[1] = x16;
          if (!tls_symbol_operand (operands[1], E_SImode))
            return -1;
          return 70; /* tls_arg */

        case 11:
          if (GET_MODE (x2) != E_BLKmode)
            return -1;
          x16 = XVECEXP (x2, 0, 0);
          if (!rtx_equal_p (x16, operands[0]))
            return -1;
          return 72; /* *memory_barrier */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_3 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 3:
          if (pattern2 (x1) != 0)
            return -1;
          x2 = XVECEXP (x1, 0, 1);
          x3 = XEXP (x2, 1);
          x4 = XEXP (x3, 1);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != UNSPEC
              || XVECLEN (x5, 0) != 1)
            return -1;
          x6 = XVECEXP (x5, 0, 0);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XVECEXP (x1, 0, 0);
          x8 = XEXP (x7, 1);
          x9 = XEXP (x8, 0);
          x10 = XEXP (x9, 0);
          operands[2] = x10;
          x11 = XEXP (x8, 1);
          x12 = XEXP (x11, 0);
          operands[1] = x12;
          x13 = XEXP (x2, 0);
          operands[0] = x13;
          x14 = XEXP (x3, 0);
          if (!rtx_equal_p (x14, operands[0]))
            return -1;
          switch (XINT (x5, 1))
            {
            case 12:
              if (!register_operand (operands[2], E_SImode)
                  || !register_operand (operands[0], E_SImode)
                  || !
#line 1307 "../../gcc-10.2.1-20200826/gcc/config/xtensa/xtensa.md"
(TARGET_LOOPS && optimize))
                return -1;
              return 47; /* zero_cost_loop_start */

            case 13:
              if (pnum_clobbers != NULL
                  && nonimmediate_operand (operands[2], E_SImode)
                  && nonimmediate_operand (operands[0], E_SImode)
                  && 
#line 1324 "../../gcc-10.2.1-20200826/gcc/config/xtensa/xtensa.md"
(TARGET_LOOPS && optimize))
                {
                  *pnum_clobbers = 1;
                  return 48; /* zero_cost_loop_end */
                }
              if (!register_operand (operands[2], E_SImode)
                  || !register_operand (operands[0], E_SImode)
                  || !
#line 1340 "../../gcc-10.2.1-20200826/gcc/config/xtensa/xtensa.md"
(TARGET_LOOPS && optimize))
                return -1;
              return 49; /* loop_end */

            default:
              return -1;
            }

        case 4:
          if (pattern2 (x1) != 0
              || pattern7 (x1) != 0)
            return -1;
          x7 = XVECEXP (x1, 0, 0);
          x8 = XEXP (x7, 1);
          x9 = XEXP (x8, 0);
          x10 = XEXP (x9, 0);
          operands[2] = x10;
          if (!nonimmediate_operand (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x8, 1);
          x12 = XEXP (x11, 0);
          operands[1] = x12;
          x2 = XVECEXP (x1, 0, 1);
          x13 = XEXP (x2, 0);
          operands[0] = x13;
          if (!nonimmediate_operand (operands[0], E_SImode))
            return -1;
          x15 = XVECEXP (x1, 0, 3);
          x16 = XEXP (x15, 0);
          operands[3] = x16;
          if (!scratch_operand (operands[3], E_SImode))
            return -1;
          x3 = XEXP (x2, 1);
          x14 = XEXP (x3, 0);
          if (!rtx_equal_p (x14, operands[0])
              || !
#line 1324 "../../gcc-10.2.1-20200826/gcc/config/xtensa/xtensa.md"
(TARGET_LOOPS && optimize))
            return -1;
          return 48; /* zero_cost_loop_end */

        case 2:
          x7 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x7))
            {
            case SET:
              x8 = XEXP (x7, 1);
              switch (GET_CODE (x8))
                {
                case REG:
                case SUBREG:
                case MEM:
                  x17 = XEXP (x7, 0);
                  switch (GET_CODE (x17))
                    {
                    case PC:
                      x2 = XVECEXP (x1, 0, 1);
                      if (GET_CODE (x2) != USE)
                        return -1;
                      x13 = XEXP (x2, 0);
                      if (GET_CODE (x13) != LABEL_REF)
                        return -1;
                      operands[0] = x8;
                      if (!register_operand (operands[0], E_SImode))
                        return -1;
                      x18 = XEXP (x13, 0);
                      operands[1] = x18;
                      return 54; /* tablejump_internal */

                    case REG:
                    case SUBREG:
                      operands[0] = x17;
                      if (!register_operand (operands[0], E_SImode))
                        return -1;
                      x2 = XVECEXP (x1, 0, 1);
                      if (GET_CODE (x2) != SET)
                        return -1;
                      x3 = XEXP (x2, 1);
                      if (GET_CODE (x3) != UNSPEC_VOLATILE
                          || XVECLEN (x3, 0) != 3
                          || XINT (x3, 1) != 5
                          || GET_MODE (x3) != E_SImode)
                        return -1;
                      operands[1] = x8;
                      if (!mem_operand (operands[1], E_SImode))
                        return -1;
                      x19 = XVECEXP (x3, 0, 1);
                      operands[2] = x19;
                      if (!register_operand (operands[2], E_SImode))
                        return -1;
                      x20 = XVECEXP (x3, 0, 2);
                      operands[3] = x20;
                      if (!register_operand (operands[3], E_SImode))
                        return -1;
                      x21 = XVECEXP (x3, 0, 0);
                      if (!rtx_equal_p (x21, operands[1]))
                        return -1;
                      x13 = XEXP (x2, 0);
                      if (!rtx_equal_p (x13, operands[1]))
                        return -1;
                      return 74; /* sync_compare_and_swapsi */

                    default:
                      return -1;
                    }

                case UNSPEC_VOLATILE:
                  if (pattern3 (x7) != 0)
                    return -1;
                  x2 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x2) != CLOBBER)
                    return -1;
                  x22 = XVECEXP (x8, 0, 0);
                  operands[0] = x22;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x13 = XEXP (x2, 0);
                  operands[1] = x13;
                  if (!scratch_operand (operands[1], E_SImode))
                    return -1;
                  return 60; /* eh_set_a0_windowed */

                default:
                  return -1;
                }

            case RETURN:
              x2 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x2) != USE)
                return -1;
              x13 = XEXP (x2, 0);
              if (GET_CODE (x13) != REG
                  || REGNO (x13) != 0
                  || GET_MODE (x13) != E_SImode
                  || !
#line 1667 "../../gcc-10.2.1-20200826/gcc/config/xtensa/xtensa.md"
(xtensa_use_return_instruction_p ()))
                return -1;
              return 58; /* return */

            case UNSPEC_VOLATILE:
              if (XVECLEN (x7, 0) != 1
                  || XINT (x7, 1) != 6)
                return -1;
              x2 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x2) != CLOBBER)
                return -1;
              x23 = XVECEXP (x7, 0, 0);
              operands[0] = x23;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x13 = XEXP (x2, 0);
              operands[1] = x13;
              if (!scratch_operand (operands[1], E_SImode))
                return -1;
              return 61; /* eh_set_a0_call0 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x24 = XEXP (x1, 0);
      if (GET_CODE (x24) != MEM)
        return -1;
      x25 = XEXP (x24, 0);
      operands[0] = x25;
      if (!call_insn_operand (operands[0], E_SImode))
        return -1;
      x26 = XEXP (x1, 1);
      operands[1] = x26;
      return 55; /* call_internal */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 59; /* nop */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x1, 0) != 1)
        return -1;
      switch (XINT (x1, 1))
        {
        case 6:
          if (pnum_clobbers == NULL)
            return -1;
          x7 = XVECEXP (x1, 0, 0);
          operands[0] = x7;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 61; /* eh_set_a0_call0 */

        case 8:
          x7 = XVECEXP (x1, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 62; /* blockage */

        case 7:
          x7 = XVECEXP (x1, 0, 0);
          operands[0] = x7;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          return 68; /* set_thread_pointersi */

        default:
          return -1;
        }

    case TRAP_IF:
      x24 = XEXP (x1, 0);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x26 = XEXP (x1, 1);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 64; /* trap */

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 2)
        return -1;
      x7 = XVECEXP (x1, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 66; /* *unspec_nop */

    default:
      return -1;
    }
}

rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 1);
      switch (GET_CODE (x2))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[1] = x2;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!nonimmed_operand (operands[0], E_DImode)
                  || !move_operand (operands[1], E_DImode)
                  || !
#line 740 "../../gcc-10.2.1-20200826/gcc/config/xtensa/xtensa.md"
(reload_completed))
                return NULL;
              return gen_split_1 (insn, operands);

            case E_DFmode:
              if (!nonimmed_operand (operands[0], E_DFmode)
                  || !move_operand (operands[1], E_DFmode)
                  || !
#line 1014 "../../gcc-10.2.1-20200826/gcc/config/xtensa/xtensa.md"
(reload_completed))
                return NULL;
              return gen_split_2 (insn, operands);

            default:
              return NULL;
            }

        case UNSPEC_VOLATILE:
          if (XVECLEN (x2, 0) != 1
              || XINT (x2, 1) != 1
              || GET_MODE (x2) != E_SImode
              || pattern4 (x1) != 0
              || !
#line 1859 "../../gcc-10.2.1-20200826/gcc/config/xtensa/xtensa.md"
(reload_completed && !frame_pointer_needed))
            return NULL;
          return gen_split_6 (insn, operands);

        default:
          return NULL;
        }

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 4:
          if (pattern2 (x1) != 0)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          x5 = XEXP (x4, 1);
          if (GET_MODE (x5) != E_SImode
              || pattern7 (x1) != 0)
            return NULL;
          x6 = XVECEXP (x1, 0, 0);
          x7 = XEXP (x6, 1);
          x8 = XEXP (x7, 0);
          x9 = XEXP (x8, 0);
          operands[0] = x9;
          if (!nonimmediate_operand (operands[0], E_SImode))
            return NULL;
          x10 = XEXP (x7, 1);
          x11 = XEXP (x10, 0);
          operands[1] = x11;
          x12 = XEXP (x4, 0);
          operands[2] = x12;
          if (!nonimmediate_operand (operands[2], E_SImode))
            return NULL;
          x13 = XVECEXP (x1, 0, 3);
          x14 = XEXP (x13, 0);
          operands[3] = x14;
          if (!scratch_operand (operands[3], E_VOIDmode))
            return NULL;
          x15 = XEXP (x5, 0);
          if (!rtx_equal_p (x15, operands[0])
              || !
#line 1360 "../../gcc-10.2.1-20200826/gcc/config/xtensa/xtensa.md"
(TARGET_LOOPS && optimize && reload_completed))
            return NULL;
          return gen_split_3 (insn, operands);

        case 2:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x12 = XEXP (x4, 0);
          operands[1] = x12;
          if (!scratch_operand (operands[1], E_SImode))
            return NULL;
          x6 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x6))
            {
            case SET:
              x7 = XEXP (x6, 1);
              if (GET_CODE (x7) != UNSPEC_VOLATILE
                  || pattern3 (x6) != 0)
                return NULL;
              x16 = XVECEXP (x7, 0, 0);
              operands[0] = x16;
              if (!register_operand (operands[0], E_SImode)
                  || !
#line 1768 "../../gcc-10.2.1-20200826/gcc/config/xtensa/xtensa.md"
(reload_completed))
                return NULL;
              return gen_split_4 (insn, operands);

            case UNSPEC_VOLATILE:
              if (XVECLEN (x6, 0) != 1
                  || XINT (x6, 1) != 6)
                return NULL;
              x17 = XVECEXP (x6, 0, 0);
              operands[0] = x17;
              if (!register_operand (operands[0], E_SImode)
                  || !
#line 1780 "../../gcc-10.2.1-20200826/gcc/config/xtensa/xtensa.md"
(reload_completed))
                return NULL;
              return gen_split_5 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  return NULL;
}
